-- The empty block of IT 
--
-- Signals:
--   redge_pre: re[i-1], right edge signal
--   redge: re[i], right edge signal
--   water: w[i], water signal
--   empty_pre: empty_carry[i], empty carry signal
--   empty_nxt: empty_carry[i+1], empty carry signal
--   empty: subempty[i], empty signal
--   c: two bits of the output literal.

library ieee;
use ieee.std_logic_1164.all;

entity it_empty is
  port (c : in std_logic_vector (0 to 1);
        redge_pre, redge, water : in std_logic;
        empty_pre : in std_logic;
        empty_nxt, empty : out std_logic);
end;

architecture dataflow of it_empty is

signal empty_nxt_tmp : std_logic;

begin

  empty_nxt_tmp <= (redge_pre and (not c(0)) and (not c(1))) or
            ((not redge_pre) and empty_pre and (not c(0)) and (not c(1)));

  empty <= empty_nxt_tmp and redge and (not water);

  empty_nxt <= empty_nxt_tmp;

end dataflow;

