/*  File: cubeoper.h */
#include <sys/time.h>
#define MAXCUBES 1024   /* the max cubes in a array of cubes */

/* The cube is represent by a long int(4-byte, 32-bit). Since this program
** only handle binary variables, a cube has at most 16 binary variables.
** The 32 bits are used from left to right, which means the first cube is
** represented by the highest two bits.
*/
typedef unsigned long CUBE;

/* The structure is used to represent an array of cubes */
struct ArrayOfCubes
{ unsigned char numvar;
  int           numcube;
  CUBE          cube[MAXCUBES];
};

typedef struct ArrayOfCubes ARRAYOFCUBES;

/* Functions' definition. see file cubeoper.c */
void getvar(CUBE *cube, short idx, short *value);
void setvar(CUBE *cube, short idx, short *value);
void storecube(ARRAYOFCUBES *parray, CUBE *pcube);
void skip_line(FILE *fp);
char *get_word(FILE *fp, char *word);
int str2pn(char *str, int nvar, CUBE *pcube);
void pn2str(CUBE *pcube, int nvar, char *str);
void read_cubes(FILE *fp, ARRAYOFCUBES *cubes);
void showarray(ARRAYOFCUBES *parray, char *name);
void dsharp(CUBE cubea, CUBE cubeb, int numvar, ARRAYOFCUBES *parray);
void copyarrcube(ARRAYOFCUBES *parraya, ARRAYOFCUBES *parrayb);
void dsharparr(ARRAYOFCUBES *parraya,ARRAYOFCUBES *parrayb,ARRAYOFCUBES *pres);
void difftv(struct timeval *tv1, struct timeval *tv2, struct timeval *tvdiff);

